%define debug_package %{nil}

Summary: Open X Input Method Server.
Name: oxim
Version: 1.0.1
Release: 1
License: GPL
Group: System/Internationalization
Source0: %{name}-%{version}.tar.gz
Requires: zlib
Requires(post,preun): /usr/sbin/alternatives
BuildRequires: zlib-devel
Buildroot: %{_tmppath}/%{name}-buildroot

Obsoletes: xcin >= 3.0.0

%description
An X Input Method Server.

%package gtk-immodule
Summary: OXIM context plugin for Gtk input method module.
Group:   System/Internationalization
Requires: %{name} = %{version}
BuildRequires: gtk2-devel

%description gtk-immodule
OXIM context plugin for Gtk input method module.

%package bimsphone-module
Summary: Chinese lexicons bimsphone input method.
Group:   System/Internationalization
Requires: %{name} = %{version}
Requires: libtabe >= 0.2.6
BuildRequires: libtabe-devel >= 0.2.6
BuildPrereq: db4-devel,libtabe-devel

%description bimsphone-module
Chinese lexicons bimsphone input method.

%package unicode-module
Summary: Unicode input method.
Group:   System/Internationalization
Requires: %{name} = %{version}

%description unicode-module
Unicode input method.

%package chewing-module
Summary: Chewing input method.
Group:   System/Internationalization
Requires: %{name} = %{version}
Requires: libchewing >= 0.2.7
Requires: libchewing-data >= 0.2.7
BuildRequires: libchewing-devel >= 0.2.7

%description chewing-module
Chewing input method.

%prep

rm -rf $RPM_BUILD_ROOT

%setup -q

%build
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
	--enable-static=no

make

%install
DESTDIR=$RPM_BUILD_ROOT make install-strip
script_dir=$RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit/xinput.d
mkdir -p ${script_dir}
echo "XIM=oxim" > ${script_dir}/%{name}
echo "XIM_PROGRAM=oxim" >> ${script_dir}/%{name}
echo "XIM_ARGS=\"-x oxim\"" >> ${script_dir}/%{name}
find $RPM_BUILD_ROOT -type f -name "*.la" -exec rm -f {} \;

%post
/sbin/ldconfig
alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/zh_TW xinput-zh_TW %{_sysconfdir}/X11/xinit/xinput.d/%{name} 30

alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/zh_CN xinput-zh_CN %{_sysconfdir}/X11/xinit/xinput.d/%{name} 30

alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/zh_HK xinput-zh_HK %{_sysconfdir}/X11/xinit/xinput.d/%{name} 30

alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/zh_SG xinput-zh_SG %{_sysconfdir}/X11/xinit/xinput.d/%{name} 30

alternatives --install %{_sysconfdir}/X11/xinit/xinput.d/en_US xinput-en_US %{_sysconfdir}/X11/xinit/xinput.d/%{name} 30

%preun
if [ "$1" = 0 ]; then
   alternatives --remove xinput-zh_TW %{_sysconfdir}/X11/xinit/xinput.d/%{name}
   alternatives --remove xinput-zh_CN %{_sysconfdir}/X11/xinit/xinput.d/%{name}
   alternatives --remove xinput-zh_HK %{_sysconfdir}/X11/xinit/xinput.d/%{name}
   alternatives --remove xinput-zh_SG %{_sysconfdir}/X11/xinit/xinput.d/%{name}
   alternatives --remove xinput-en_US %{_sysconfdir}/X11/xinit/xinput.d/%{name}
fi

%postun -p /sbin/ldconfig

%post gtk-immodule
{
grep -v "^GTK_IM_MODULE" %{_sysconfdir}/X11/xinit/xinput.d/%{name} > /tmp/%{name}.bak
echo "GTK_IM_MODULE=%{name}" >> /tmp/%{name}.bak
cat /tmp/%{name}.bak > %{_sysconfdir}/X11/xinit/xinput.d/%{name}
rm -f /tmp/%{name}.bak

for dir in /etc/gtk-2.0/*
do
    if test -d $dir
    then
	host=`basename $dir`
	`which update-gtk-immodules` $host 2>&1 > /dev/null
    fi
done
}

%postun gtk-immodule
{
grep -v "^GTK_IM_MODULE" %{_sysconfdir}/X11/xinit/xinput.d/%{name} > /tmp/%{name}.bak
cat /tmp/%{name}.bak > %{_sysconfdir}/X11/xinit/xinput.d/%{name}
rm -f /tmp/%{name}.bak

for dir in /etc/gtk-2.0/*
do
    if test -d $dir
    then
        host=`basename $dir`
        `which update-gtk-immodules` $host 2>&1 > /dev/null
    fi
done
}

%clean 
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc {README,COPYING,AUTHORS}
%dir %{_sysconfdir}/oxim
%config %{_sysconfdir}/oxim/*
%{_bindir}/oxim2tab
%{_bindir}/oxim
%{_libdir}/liboxim.so*
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/modules
%{_libdir}/%{name}/modules/gen-inp.so
%{_libdir}/%{name}/tables/sys.tab
%{_libdir}/%{name}/tables/cnscj.tab
%{_libdir}/%{name}/tables/cnsimplex.tab
%{_libdir}/%{name}/tables/cnsphone.tab
%{_libdir}/%{name}/tables/cns11643.tab
%{_libdir}/%{name}/tables/array30.tab
%{_libdir}/%{name}/tables/ez.tab
%{_libdir}/%{name}/tables/default.phr
%{_sysconfdir}/X11/xinit/xinput.d/*

%files gtk-immodule
/usr/lib/gtk-2.0/immodules/gtk-im-oxim.so

%files bimsphone-module
%{_libdir}/%{name}/tables/bims_pinyin.tab
%{_libdir}/%{name}/modules/bimsphone.so

%files unicode-module
%{_libdir}/%{name}/modules/unicode.so

%files chewing-module
%{_libdir}/%{name}/modules/chewing.so

%changelog
